/*
this class demonstrates the use of function objects: a comparator is used for sorting instead of 'implements Comparable'
*/
public class FunctObj
{
    public static void insertionSort(String[] array, Comparator<String> comparator) {
        for (int i = 1; i < array.length; i++) {
            String x = array[i];
            int j;
            for (j = i - 1; j >= 0; j--) {
                if (comparator.compare(x,array[j]) >= 0) {
                    break;
                }
                array[j + 1] = array[j];
            }
            array[j + 1] = x;
        }
    }
    
    public static void main(String[] args)
    {
    	String[] arr={"goat","mouse","dog","hutt","elephant","wookie"};
    	
    	int i;
    	System.out.println("Original list:");
    	for(i=0;i<arr.length;i++) System.out.println((i+1)+") "+arr[i]);
    	
    	Comparator<String> comp=new RegularStringComparator();
    	//Comparator<String> comp=new LengthComparator();
    	//Comparator<String> comp=new InverseLengthComparator();
    	//Comparator<String> comp=new RandomComparator();
    	insertionSort(arr,comp);
    	System.out.println("Sorted list:");
    	for(i=0;i<arr.length;i++) System.out.println((i+1)+") "+arr[i]);
    }
}
